/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


//  xxxxxxxxxxxxxxx     wm6 variable declarations  xxxxxxxxxxxxxxxx

// Note: let and const are not used because of backward compatibility

// These variables below (17x) can be directly modified by the user on the options form: 

var lc = 1;       // minimum visible shapes

var hc = 5;     // maximum visible shapes

var wc = 1;    // number of item within each level between lc..hc

var is_shuffle=false;   // random shuffle items or not

var is_cor= true;       // if (is_cor == true) one of the options offered after the delay will always be equal to the stimulus before the delay;  else:  after the delay period the exact solution does not have to be displayed at all

var uniq= false;  // (uniq==false) => Shapes within drawings can be different  else => "Shapes within drawing will be unique (different) if possible 

var wait = 10;   // number of basic time cycles before main stimulus (shapes) exposition. Units = number of basic timer resolution (clock=100ms). Time of displaying the fixing cross

var time = 5;     // stimulus exposition time in ms. Units = number of basic timer resolution (clock=100ms)

var delay = 10;   // delay between stimulus and user response. Units = number of basic timer resolution (clock=100ms)

/*  stype => main stimulator type => difference between stimulus befor delay (target) and stimulus after delay(options)
  "0" = shape and color 
  "1" = only color
  "2" = only shape 
  "3" = only position  */
var stype = "0"; 
   
var ch = 4;       // choices count (1..10). Count of stimulus after delay

var size = 1;         // reverse shape size = (3 + 3 - size); Median = 3. Don't change min and max range without change dependent source code see setVarPar()   

var s_max= 40;     // maximum shape type (40 or 21). Don't change this see: drawShape() function. Depends on document.getElementById("resol").value

var tcolor= false;   // if (tcolor==false) => only basic different 10 colors are used ; else if (tcolor==true) all colors will be used (only for stype="0" or "1")

var isCross=true;       // if isCross=true =>  The cross will appear in the center of the screen before the main stimulus 

var demo = false;       // if (demo == true) => show correct solution

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 

// Other wm6 variables and constants:

var clock = 100;  // basic timer resolution in ms

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var step = -1;   // global timer counter 

var item = 0;   // current item      

var cor = [];   // correct answer for each item

var ans = [];  //  user (client) answer for each item 

var r;      // shape radius (square base -width/height)  - x and y raster

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var itemCnt;       // total item count  =>   itemCnt= wc*(hc-lc+1); 
      
var stim_b = [];        // canvas (viewport) choices (options) bounds => stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch

/*  stim = jagged array= for each item [item][option][shape] is separate array:
[ 0.index= show(1) or hide(0), 
  1.index = x screen coord, 
  2.index = y screen coord
  3.index = shape color
  4.index = shape type (circle, polygon, star,..) 
]
*/
var stim = [];  


//  xxxxxxxxxxxxxxx     wm6 functions  xxxxxxxxxxxxxxxx


// create/start Timer, [center panels], and show start panel.. 
function init() 
{    
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {wm6Timer()},clock); 
  if (!supportedTransform())  {
    doCenter(document.getElementById("start"));
  }  
  showStart(); 
  if (isStorage() && storageAvailable('localStorage'))  
  {
    document.getElementById("store_group").disabled= false;
  }
  else 
  {
    document.getElementById("store_msg").textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline).";
    document.getElementById("store_group").disabled= true;  
    document.getElementById("clr_store").disabled= true;     // IE11 bug  => childrens are not auto disabled
    document.getElementById("store").disabled= true;          // IE11 bug => childrens are not auto disabled
  }  
  document.onkeyup = cancelPScreen;    
}


//  check for browser supported transform
function supportedTransform() 
{
  var prefixes = "transform WebkitTransform MozTransform OTransform msTransform".split(" ");
  var div = document.getElementById("wrapper");
  for(var i = 0; i < prefixes.length; i++) {
    if(div && div.style[prefixes[i]] !== undefined) {
      return prefixes[i];
    }
  }
  return false;
}


// center start panel
function doCenter(e)  
{      
  e.style= (window.innerWidth > 600 && window.innerHeight > 600 ) 
  ? "position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;"  
  : "position:absolute;min-width:75%;min-height:75%;margin:auto;overflow:auto;";  
}


// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google-wrapper").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// cancel print screen => reset research
// function is implemented because of possible cheating (we can not prevent the use of cameras on mobile phones)
function cancelPScreen(e)   {                                 
  var keyCode = e.keyCode ? e.keyCode : e.which;
  if (keyCode == 44 && step >= wait && step <= wait+time) {      
     step = -1;         // stop timer (nop, idle, do none, Timer no operation)   
     alert("It is forbidden to press the Print Screen key while displaying stimuli before the delay. The research is interrupted. You probably need to adjust your research settings again.");
     var canvas= document.getElementById("canvas");
     canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // clear canvas 
     init();
     e.preventDefault();   // redundant don't work     
     return false;   
  } 
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               // Code for localStorage/sessionStorage.     
  } 
  else {
    return false;           // code for no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try 
  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// show forms with application options
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("logo").style.display="none"; 
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").style="text-align:center";  // bug? auto-remove style when element.style.display="none"
  document.getElementById("instructions").style.display ="none";     
  if ( document.getElementById("store_group").disabled === false && localStorage.getItem("wm6-v1.0")) 
  {
    var cnt= JSON.parse(localStorage.getItem("wm6-v1.0")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " WM6 results stored in your web browser";
  }
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").style="text-align:center";  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").style="text-align:center";   // bug?
  document.getElementById("instructions").style.display ="block";
  refMsg();  
}

       
// refresh variable research Options (update *_msg label) => give user short option HELP
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";    
  
  // Items (6x)
  if ( my_id === "lc")  {
    if (e.validity.valid)  {           
      msg.removeAttribute("class");       
      msg.textContent= "";       //msg.textContent=  e.value; 
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    } 
    refItem();
  }   
     
  else if ( my_id === "hc")  {
    if (e.validity.valid)  {     
      msg.removeAttribute("class");         
      msg.textContent= "";         //   msg.textContent=  e.value;
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
      msg.setAttribute("class", "error");
    }  
    refItem();
  }      
  
  else if ( my_id === "wc")  {    
    if (e.validity.valid)  {       
      msg.removeAttribute("class");        
      msg.textContent= "";        //msg.textContent=  e.value; 
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    }         
    refItem();
  } 
  
  else if (my_id === "is_shuffle")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Items will be displayed from easier (Start level) to more difficult (Final level)" : "Items will be mixed randomly";
  }      
  
  else if (my_id === "is_cor")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "None of the drawings after the delay period must always be accurate" : "One of the drawings after the delay period will always be equal to the drawing before the delay";
  }    
  
  else if (my_id === "uniq")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Geometric shapes can be repeated within the same drawing" : "Shapes within drawing will be unique (different) if possible";  
    document.getElementById("resol").disabled =  (e.value === "0")  ? false : true;    // greater value s_max for unique shapes must be used. This variable uniq takes precedence over the variable resol (s_max)
  }    
  
  // Temporal resolution (3x)      
  else if ( my_id === "wait")  {
    if (e.validity.valid)  {
      msg.textContent=  "Time between stimuli. This is also time interval when it is possible to cancel an already selected answer "  + e.value + " ms"; 
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
      msg.setAttribute("class", "error");
    }          
  }    
  
  else if ( my_id === "time")  {
    if (e.validity.valid) {
      msg.textContent= e.value + " ms"; 
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    } 
  }    
  
  else if ( my_id === "delay")  {
    if ( e.validity.valid ) {
      msg.textContent= e.value + " ms";
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    }
  }                
       
  // Paradigm design (7x)
  else if (my_id === "stype")  {
     if (e.value === "0")  {
       msg.textContent= "Drawings with different colors or shapes will be displayed"; 
       document.getElementById("tcolor").disabled = false;
       document.getElementById("uniq").disabled = false; 
       document.getElementById("resol").disabled = false;
     }
     else if (e.value === "1")  {
       msg.textContent=  "Circles of different colors will be displayed";
       document.getElementById("tcolor").disabled = false; 
       document.getElementById("uniq").disabled = true; 
       document.getElementById("resol").disabled = true;            
     }
      else if (e.value === "2")  {  
        msg.textContent= "Different geometric shapes will always be displayed in black"; 
        document.getElementById("tcolor").disabled = true;
        document.getElementById("uniq").disabled = false;
        document.getElementById("resol").disabled = false;
      } 
      else if (e.value === "3")  {  
        msg.textContent="Black circles will be displayed and their spatial position on the screen will be varied";
        document.getElementById("tcolor").disabled = true;
        document.getElementById("uniq").disabled = true;  
        document.getElementById("resol").disabled = true;
      }        
  }    
 
  else if ( my_id === "ch")  {
    if (e.validity.valid)  {           
      msg.removeAttribute("class");       
      msg.textContent= "";       
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");  
    } 
    document.getElementById("is_cor").disabled = (e.value === "1") ? true : false;      // for only one option stimulus is_cor must be false
  }      
                    
  else if ( my_id === "size")  {
    if ( e.validity.valid ) {                     
      msg.textContent= "Higher number = larger drawing. Lower number = smaller drawing. Also, significantly depends on the Final level. The higher it is, the size of shapes is smaller and vice versa."; 
      msg.removeAttribute("class");            
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    }
  }    
  
  else if (my_id === "resol")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "Suitable for lower screen resolutions and/or more options after a delay interval. Only basic geometric shapes that are easier to distinguish will be used." : "Suitable for higher screen resolutions and/or fewer options after a delay interval. All geometric shapes will be used.";
  }  
    
  else if (my_id === "tcolor")  {                                                                                                                                            
    msg.textContent= (e.value === "0") ? "The drawings will only appear in 10 different colors (recommended)." : "The drawings will be displayed in all possible colors (in some percent of cases it is possible to generate very similar colors that are difficult to distinguish).";
  }      
  //  else if (my_id === "is_cross")  nop      
  else if ( my_id === "demo")  
  {
    if (e.checked) {
      msg.textContent= " (Yes -The correct answer will have a background in this color)";
      msg.setAttribute("style", "background-color:#FFFFF0");   // ivory
    }
    else  {
      msg.textContent=" (No)";
      msg.removeAttribute("style");
    }    
  }
  // storage (1x)
  else if (my_id === "store")  {                                                                                                                                            
    msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
  }  
  
  refMsg();   
}


// update item count on options form and check lc <= hc and update  label itemCnt = wc*(hc-lc+1);
function refItem()  
{
   var _lc = document.getElementById("lc");
   var _hc = document.getElementById("hc");
   var _wc= document.getElementById("wc");
   var _item= document.getElementById("item_cnt");
   var lc_msg= document.getElementById("lc_msg");
   var hc_msg= document.getElementById("hc_msg");    
   if (_lc.validity.valid  && _hc.validity.valid && _wc.validity.valid)   
   {                      
     if  (parseInt(_lc.value,10) > parseInt(_hc.value,10))  
     {
       lc_msg.textContent= "The starting level must not be higher than the final level";  
       hc_msg.textContent= "The starting level must not be higher than the final level";
       lc_msg.setAttribute("class", "error");
       hc_msg.setAttribute("class", "error");    
       _item.textContent= "Total number of items: Invalid value"; 
       _item.setAttribute("class", "error");
     } 
     else   {                                                                                               
       lc_msg.removeAttribute("class");    //lc_msg.textContent= _lc.value;
       hc_msg.removeAttribute("class");   //hc_msg.textContent= _hc.value; 
       _item.textContent=  "Total number of items: " +  ( parseInt(_wc.value,10) * (parseInt(_hc.value,10)-parseInt(_lc.value,10)+1));      
       _item.removeAttribute("class");
     }
   } 
   else  
   {
     _item.textContent= "Total number of items: Invalid value"; 
     _item.setAttribute("class", "error");
   }    
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 
 if ( optionsValid() )   {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").style="text-align:center;color:#000000"; 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").style= "text-align:center;color:#ff0000;font-weight:bold"; // safari 5.1.7 bug? => this don't work
  } 
}


// setVarPar() is called before this function  
function optionsValid()  
{     
  var res=  document.getElementById("lc").validity.valid && 
    document.getElementById("hc").validity.valid &&
    (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value,10))  &&   
    document.getElementById("wc").validity.valid  &&  
    
    document.getElementById("wait").validity.valid && 
    document.getElementById("time").validity.valid &&       
    document.getElementById("delay").validity.valid &&
    
    document.getElementById("ch").validity.valid &&
    document.getElementById("size").validity.valid;
    return res;       // Firefox parser don't execute code ok without res var           
}


// start wm6 Research (Test) 
function startTest(e)   
{     
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
   var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large itemCnt
  document.getElementById("logo").style.display="none"; 
  document.getElementById("google-wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";            
  item=0;
  step=0;   // "activate" Timer   
}


// set application variable parameters; don't use this code in setPar() => eq: document.getElementById("time").value are not updated to real value!!  
function setVarPar()  {   
  
  if (document.getElementById("lc").validity.valid && document.getElementById("hc").validity.valid 
    && (parseInt(document.getElementById("lc").value,10) <= parseInt(document.getElementById("hc").value, 10) ) )   {  
      lc= parseInt(document.getElementById("lc").value, 10); 
      hc= parseInt(document.getElementById("hc").value, 10); 
  }
  
  if (document.getElementById("wc").validity.valid) wc= parseInt(document.getElementById("wc").value, 10);        
  
  is_shuffle= (document.getElementById("is_shuffle").value === "1") ? true: false;
  
  is_cor= (document.getElementById("is_cor").value === "1") ? true: false;
  
  uniq= (document.getElementById("uniq").value === "1") ? true: false;
  
  if (document.getElementById("wait").validity.valid) wait= Math.round(parseInt(document.getElementById("wait").value, 10)/clock);
  
  if (document.getElementById("time").validity.valid) time= Math.round(parseInt(document.getElementById("time").value, 10)/clock);  
  
  if (document.getElementById("delay").validity.valid) delay= Math.round(parseInt(document.getElementById("delay").value, 10)/clock);     
    
  stype = document.getElementById("stype").value;   
  if (stype != "0" && stype != "1"  && stype != "2" && stype != "3") stype= "0";  //redundant but if someone change wm6 html
  
  if (document.getElementById("ch").validity.valid)  ch = parseInt(document.getElementById("ch").value, 10);     // stimulus after delay (options) count           
  
  if (document.getElementById("size").validity.valid) {
    size = parseInt(document.getElementById("size").value, 10);
    size =  (3 + 3 - size); // size => reverse shape size (3 + 3 - size). median value in wm6.html is 3. recode values: 5=>1,4=>2,3=>3,2=>4,1=>5     
  }
  
  tcolor= (document.getElementById("tcolor").value === "0") ? false: true;  // false => only use 10 basic colors; true => use full random colors palette     
  
  isCross= (document.getElementById("is_cross").value === "1") ? true: false;   // if (isCross==true) => The cross will appear in the center of the screen before the main stimulus         
  
  demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct solution
  
  store= ( document.getElementById("store_group").disabled === false && document.getElementById("store").value === "1") ? true : false;
  
  if ( !uniq &&  (stype === "0" || stype === "2")  && !document.getElementById("resol").disabled && document.getElementById("resol").value === "0")  {
    s_max= 21;
  }
  else  {
    s_max= 40;
  }  
  
}


// set internal application research parameters
function setPar()  {  
  itemCnt = wc*(hc-lc+1);               
  stim_b = [];    // bounds for choices
  stim = [];   //  jagged array [item][] Within each [item] is separate array with grid coordinates 
  cor = [];  // correct solution for each item
  ans = [];  //  user answers for each item (dependent var)
  for (var j= 0; j<itemCnt; j++)   {
    ans[j]= 0;    // default on no answer = 0
  } 
}


// main wm6 stimulus generator function
function stimGenerator()  
{ 
  setPar();
  setChoicesBounds();
  var raster= setRaster(0); 
  
  var i= 0;    // ordinal item count [0..itemCnt-1] 
  for (var j=lc; j<=hc; j++)  
  {  // from low level to high level      
     
    for (var k=1; k<=wc; k++)  
    {    //   from lf to hc (wc-times)  
      stim[i]= []; 
      for (var m=0; m<=ch; m++)  
      {  // for each choices within wc          
        var b= ( m===0 ) ? true: false;  // if (b) generate color and shapes
        stim[i][m]= setCoord(stim_b[m][0], stim_b[m][1], stim_b[m][2], stim_b[m][3], raster, b);
        if (m === 0) {                                     
          var tmp= stim[i][m];  // remember match stimulus (stimulus before delay)
        }
        else 
        {    
          for (var h in stim[i][m]) 
          {            
            stim[i][m][h][3]= tmp[h][3]; // copy color from match stimulus
            stim[i][m][h][4]= tmp[h][4]; // copy shape from match stimulus
          }
        }                            
      }                
      i++;    // next item
    }  // k= within each level
  }   // j = from low level to high level
         
  setRadius();  
  setStim();  
}


// set canvas (viewport) choices (options) bounds        
// stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch
function setChoicesBounds()  
{
  var canvas= document.getElementById("canvas");     
  canvas.width= window.innerWidth;       // stretch canvas to parent 
  canvas.height= window.innerHeight - document.getElementById("footer").scrollHeight;  
  
  var hor = (canvas.width > canvas.height) ? true : false; 
  var total = (hor) ? canvas.width : canvas.height;  // maximum available viewport x(y) space for each row/column  
  var xs= canvas.width/2,  ys= canvas.height/2;    // (xs,ys) => viewport center
  
  // p = (total viewport space reserved for all options in one row/column ) / 100;  
  // full row/column space is 1. in this case 80% of canvas.width is reserved for all option in on row   
  var p= 0.8;   // const p=0.8;
  
  // 1. set MATCH stimulus bounds. match stimulus is stimulus before delay (first stimulus - only one).
  var w= Math.round(p*total/(ch+1));    // w= default width (and height) for match stimulus and all options (match stimulus and sample stimulus) in each row/column                  
  w= (hor) ? Math.min(w, p*canvas.height): Math.min(w, p*canvas.width);
  // update default width for all options if options are in multiple row/column layout
  switch (window.ch)  
  {    
    case 4:
    case 6:
    case 8:
    case 10:
      // options are in 2 rows (columns) 
      var tmp= (hor) ? divLine(0, canvas.width, -1/2) : divLine(0,canvas.height, -1/2); 
      w= Math.min(w, tmp );    // update default width for all options in each row/column 
      break;
    case 9:
        // options are in 3 rows (columns)
        var tmp= (hor) ? divLine(0, canvas.width, -1/3) : divLine(0,canvas.height, -1/3); 
        w= Math.min(w, tmp );    // update default width for all options in each row/column       
    /*default: case 1: case 2: case 3: case 5: case 7: */          
  }
         
  // finaly set screen position for match stimulus
  stim_b[0]= [Math.round(xs-w/2), Math.round(ys-w/2), Math.round(xs+w/2), Math.round(ys+w/2)];  // match stimulus is always in screen center   

  // 2. set OPTIONS stimulus position on screen. options stimulus are stimuli after delay. they all have equal width and height like match stimulus 
  switch (window.ch)  
  {
    
    case 4:
    case 6:
    case 7:
    case 8: 
    case 9:
    case 10:                  
      var i= 1, new_row= false, n1, n2, x, y;
      var cnt= (ch === 9) ? ch/3 : Math.ceil(ch/2);  // maximum stimulus (options) within each row (column)
      for (var j=1; j<=ch; j++)  
      {                       
        if (new_row) i=1;   // reset counter                    
        new_row= (j % cnt === 0) ? true : false;  // reset counter in next iteration if neccesary                          
        // n1 = divide screen ratio for each option within each rows (columns)
        n1 = -i/(cnt-i+1);  //n1 = (ch === 7 && j > 4) ? -i/(3-i+1) : -i/(cnt-i+1);          
        // n2 = divide screen ratio for rows (columns). example divide line into 3 (4) equal segments => lambda= 3: [-1/3, -2/2, -3/1]
        if (ch === 9) 
        {   // divide screen in 3 equal rows/columns 
          if (j <= cnt) {
            n2= -1/3;
          }
          else if (j <= cnt*2)  {
            n2= -2/2;
          }
          else  {
            n2= -3/1;
          }  
        }
        else  // divide screen in 2 equal rows/columns
        {
          n2= (j <= cnt) ? -1/2: -2/1;   // divide screen in 2 equal rows/columns 
        }
        x= (hor) ? divLine(0, canvas.width, n1)  : divLine(0, canvas.width, n2);    
        y= (hor) ? divLine(0, canvas.height, n2) : divLine(0, canvas.height, n1);            
        if (hor) {
          stim_b[j]= [Math.round(x-w/2), Math.round(y-w/2), Math.round(x+w/2), Math.round(y+w/2)];   // 0 = left; [1] = top; [2] = right; [3]= bottom            
        }
        else  {
          stim_b[j]= [Math.round(x-w/2), Math.round(y-w/2), Math.round(x+w/2), Math.round(y+w/2)]; // 0 = left; [1] = top; [2] = right; [3]= bottom            
        }
        i++;                            
      }                       
      break;
                            
      default: /* case 1: case 2: case 3: case 5: */                                                                      
         // set match stimulus bounds. match stimulus is stimulus before delay. sample stimulus are stimuli after delay 
        //var w= Math.round(p*total/(ch+1));    // w= width (height) of all options (match stimulus and sample stimulus) in each row/column                     
        //stim_b[0]= [Math.round(xs-w/2), Math.round(ys-w/2), Math.round(xs+w/2), Math.round(ys+w/2)];  // match stimulus is always in screen center         
        for (var j=1; j<=ch; j++)  
        {              
          var x= divLine(0, canvas.width, -j/(ch-j+1)) ;   // last arg = lambda = -m/n. example if step= 3: -1/3, -2/2, -3/1          
          var y= divLine(0, canvas.height, -j/(ch-j+1));    // y= const within each row;  last arg = lambda = -m/n. example if step= 3: -1/3, -2/2, -3/1            
          if (hor) {
            stim_b[j]= [Math.round(x-w/2), Math.round(ys-w/2), Math.round(x+w/2), Math.round(ys+w/2)]; // 0 = left; [1] = top; [2] = right; [3]= bottom              
          }
          else  {
            stim_b[j]= [Math.round(xs-w/2), Math.round(y-w/2), Math.round(xs+w/2), Math.round(y+w/2)]; // 0 = left; [1] = top; [2] = right; [3]= bottom              
          }                                      
        }                      
  }   
   
}


// divide line 
// first => first point (P1) 
// second => second point (P2)
// n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: coordinate of point (Q) between first and second point 
// if  n > 0 => point Q is witnin line; else Q is out of line
// if n = -1 => divide line into 2 equal parts
function divLine(first,second,n)  {   
  return (first-n*second)/(1-n);
}


// x1 => first point P1 x-coord
// x2 => second point P2 y-coord
// n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: x-coord of Q point
function div_x(x1,x2,n)  {   
  return (x1-n*x2)/(1-n);
}


// y1 => first point P1 y-coord
// y2 => second point P2 y-coord
// n  => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: y-coord of Q point
function div_y(y1,y2,n)  {   
  return (y1-n*y2)/(1-n);
}


// set raster for main stimulus generator function or setRadius() function
function setRaster(sender)
{
  if (stype === "3") { 
    var raster= (hc <= 3) ? (4+sender) : (hc+sender);    // if sender is stimulusGenerator()  3=>4; if sender is setRadius() => 3=>5  (hardcoded fixed values). checked ok
  }   
  else  {
    var raster=Math.ceil(Math.sqrt(hc)) + sender;     // if sender is stimulusGenerator()  => raster= Math.ceil(Math.sqrt(hc));  if sender is setRadius() =>  raster=Math.ceil(Math.sqrt(hc))+1 
  }     
  return raster;
}


// set match and sample coordinates; generate stim-coord (x,y) and default properties (visible, color, shapes type)
// divide screen section into raster equal segments (x-horizontal and y-vertical) 
// if (b===true) generate color and shapes
// return array (item) stim coordinates. 
function setCoord(_left, _top, _right, _bottom, raster, b) 
{  
  var arr= [];    //stim[i]= []; => return stim-coord for next item     
  var sel= {};  // already selected shapes => they can be selected ONLY ONCE if uniq === true
  for (var k=1; k<=raster; k++) 
  {  // divide line (screen section) into raster equal segments  => divide screen section vertical - y      
    for (var j=1; j<=raster; j++)  
    {          
      // divide line (each row) into raster equal segments again => divide screen section horizontal-x          
      // divide line horizontal -x; last arg = lambda = -m/n. example divide line into 5 equal segments: lambda= [-1/5; -2/4, -3/3; -4/2; -5/1]. example divide line into 3 equal segments=> lambda= [ -1/3, -2/2, -3/1]
      var x= div_x(_left, _right, -j/(raster-j+1));                 
      // y= const within each row;  last arg = lambda = -m/n. example divide line into 3 equal segments => lambda= 3: [-1/3, -2/2, -3/1]     
      // divide line vertical -y; last arg = lambda = -m/n. example divide line into 7 equal segments: lambda=[-1/7; -2/6; -3/5; -4/4; -5/3; -6/2; -7/1]
      // example divide line into 6 equal segments=> lambda= [-1/6; -2/5; -3/4; -4/3;-5/2;-6/1] 
      // example divide line into 4 equal segments=> lambda= [-1/4;-2/3;-3/2;-4/1]      
      var y= div_y(_top, _bottom, -k/(raster-k+1));         
      
      // see stimGenerator() => all stimulus after delay later will have overwritten values for color and shape
      if (b)
      {       // if (b) generate color and shapes
        if (stype === "0") 
        { // vary color and shape
          var col= (tcolor) ? getRndColor() : get10Color(); 
          if (uniq)
          {
            do
              var shape= getRndInt(0, s_max);
            while (typeof sel[shape] != "undefined");
            sel[shape]= shape;
          }
          else {        
            var shape= getRndInt(0, s_max); 
          }
        }
        else if (stype === "1") 
        {  // vary only color
          var col= (tcolor) ? getRndColor() : get10Color();
          var shape= 0;    // circle
        }
        else if (stype === "2") 
        {    // vary only shape
          var col= "#000000"; 
          if (uniq)
          {
            do
              var shape= getRndInt(0, s_max);
            while (typeof sel[shape] != "undefined");
            sel[shape]= shape;
          }
          else {        
            var shape= getRndInt(0, s_max); 
          }  
        }       
        else if (stype === "3") 
        {    // vary only position
          var col= "#000000"; 
          var shape= 0;  // circle
        }                              
        arr.push([0, x, y, col, shape]);     // index: [0=visible; 1 = x; 2=y; 3 = color; 4= shape]; all are invisible by default => see setStim()          
      }
      else {
        arr.push([0, x, y, null, null]);   // don't generate color and shapes index: [0=visible; 1 = x; 2=y; 3 = color; 4= shape]
      }
    } // j = horizontal (x) divide
  } // k = vertical (y) divide
  return arr;  
}


// Sets one of 10 predefined colors (can these colors be distinguished by most of the population?)
function get10Color() 
{
  var rnd =  Math.floor(Math.random()*10);   // 0..9
  switch (rnd)  
  {    
    case 0:  return "black";
    case 1:  return "silver";  // grey
    case 2:  return "red";
    case 3:  return "green";
    case 4:  return "blue";
    case 5:  return "orange";
    case 6:  return "lime";
    case 7:  return "purple";
    case 8:  return "aqua"; // olive
    case 9:  return "pink";
  }
}


// get full random colors in hex format
function getRndColor() {
  var letters = '0123456789abcdef';
  var color = '#';
  for (var i = 0; i < 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// set window.r radius
// why must be in separate function? This code don't work OK in stimGenerator() 
function setRadius()  
{ 
  var raster=setRaster(1);
  // 0 = left; [1] = top; [2] = right; [3]= bottom
  var w= (stim_b[1][2] - stim_b[1][0])/raster; // choice_width/raster = choice_height/raster = right - left = const => this choice always exists
  var h= (stim_b[1][3] - stim_b[1][1])/raster; // choice_height/raster = choice_width/raster = bottom - top = const => this choice always exists          
  window.r= Math.floor(0.5*Math.min(w,h)/size);   // size => reverse shape size (3 + 3 - size). median value in wm6.html is 3. recode values: 5=>1,4=>2,3=>3,2=>4,1=>5        
  //window.r=Math.round(0.90*window.r);    // leave 10% blank space within rect   
}


/*  
set wm6 stimulus for each item 
set difference between target stimulus and other stimulus/option
none or only one option is equal to match (before delay) stimulus, 
other stimuli are different ONLY in ONE shape (color and/or shape)
*/
function setStim()  {     
  var i= 0;        // i= item => ordinal item count [0..itemCnt-1]
  var max= stim[i][0].length;     // stimulus before delay (match) and all stimulus after delay have equal length     
  for (var vis=lc; vis<=hc; vis++)  
  {   // vis = number of visible shapes within this item
    for (var j=0; j<wc; j++)  
    {    //   from lf to hc (wc-times)                        
      // choose random visible shapes within this item
      for (var k=0; k<vis; k++)  
      {
        do  
          var rnd = Math.floor(Math.random()*max); // rnd= random choose one of shapes in all stimulus in this (i) item  
        while (stim[i][0][rnd][0] === 1);   // check if this shape is already choosen (match [0] stimulus)        
        for (var c in stim[i])      {     // c= choices within each item (i)            
          stim[i][c][rnd][0]=1;       // this shape will be visible (match stimulus + all options stimulus)          
        }
      }
      i++;     
    }
  }  
    
  // change shape (color, position) in ONLY ONE shape within each choices (except correct solution = target=match stimulus)
  for (var i in stim) 
  {     // i= item                                                             
    var correct= (is_cor && ch > 1) ? getRndInt(1,ch) : getRndInt(0,ch);    // choose correct solution, pick one of options stimulus within item (or none)
    cor[i]=correct;   // save correct solutions for each item
    do  
      var s =  Math.floor(Math.random()*max);  // random choose only one of shapes within match stimulus => s = selected shape   
    while (stim[i][0][s][0] === 0);   // selected shape must be VISIBLE (stim[i][0] = match stimulus)        
    var sel= {};  // already selected random colors/shapes/positions => they can be selected ONLY ONCE             
    // set difference between target stimulus and other stimulus/option
    for (var c in stim[i]) 
    {    // c= choices within each item  (c = 0 => match stimulus-before delay; c > 0 => sample stimulus-after delay)            
      if (c == 0 || c == correct) continue; // escape match stim and target stimulus (don't use ====)                 
      if (stype === "0")  
      {  //  "0" => change shape OR color only in only ONE shape except target
        if (Math.random() < 0.5)
        { // change color (in only ONE shape except target)
          var ind=3;  // index for color is 3 => stim[i][c][s][3]
        }
        else 
        {  // change shape type (in only ONE shape except target)
          var ind = 4;  // index for shape is 4 => stim[i][c][s][4]
        }  
        do   
          if (ind === 3) {
            var rnd =  (tcolor) ? getRndColor() :  get10Color();    // choose different color for all sample stimulus except target and match stim
          }  
          else  {
            var rnd =  getRndInt(0, s_max);   // choose different shape
          }  
        while (stim[i][0][s][ind] == rnd || typeof sel[rnd] != "undefined");  //while (stim[i][0][s][3] == col || sel[col]) => browser warning 
        stim[i][c][s][ind]= rnd; // change shape or color in all options except correct solution
        sel[rnd]= rnd;              
      }
      else if (stype === "1")  
      {  //  "1" => change only color in only ONE shape except target
        do  
          var col= (tcolor) ? getRndColor() : get10Color();  // choose different color for all sample stimulus except target and match stim  
        while (stim[i][0][s][3] == col || typeof sel[col] != "undefined");  //while (stim[i][0][s][3] == col || sel[col]) => browser warning 
        stim[i][c][s][3]= col; // change color in all shapes
        sel[col]= col;
      }      
      else if (stype === "2")  
      {   // "2" => difference is only shape
        do  
          var shape= getRndInt(0, s_max);  // choose different SHAPE for all sample stimulus except target and match stim  
        while (stim[i][0][s][4] == shape || typeof sel[shape] != "undefined");  
        stim[i][c][s][4]= shape; // change shape
        sel[shape]= shape;
      }      
      else if (stype === "3")  
      {   // "3" => difference is only position (change 2 positions)
        do  
          var pos =  Math.floor(Math.random()*max);  // random new position    
        while (stim[i][0][pos][0] === 1 || typeof sel[pos] != "undefined");   // new position must be INVISIBLE  and must be choosen only once within item
        // swap visible and invisible
        stim[i][c][s][0]= 0;     // original (match) stim is INVISIBLE
        stim[i][c][pos][3]= "#000000"; 
        stim[i][c][pos][0]= 1; // new position is VISIBLE 
        sel[pos]= pos;
      }       
                                            
    }   // for (var c in stim[i]) =>  c= choices within each item  (c = 0 => match stimulus-before delay; c > 0 => sample stimulus-after delay)     
  } 
  
  if (is_shuffle)  
  {
    stim = shuffle(stim);      
    // try to avoid:  prior item and current item are equal (maximum 5 x shuffle items). only if is_shaffle= true 
    for (var j= 1; j<=5; j++)  
    {    
      for (var i=1; i< stim.length; i++) 
      {   
        if ( areEqual(stim[i][0], stim[i-1][0]) )   {  
          stim= shuffle(stim);    // try shuffle again                
        }  
      }
    }
  } 
      
  delInv();     // always do it on END => because of  var max= stim[i][0].length and areEqual() don't work ok (undefined objects);     
  
}


// check if prior item and current item are equal (only for stimulus before delay)
function areEqual(current, prior)  
{
  for (var shape in current)  {          
    if ( current[shape][0] != prior[shape][0]  ||  current[shape][3] != prior[shape][3] || current[shape][4] != prior[shape][4]) return false; // compare colors and shapes for visible items      
  }
  return true;
}


// delete (unset) all invisible shapes because of better future performance in drawStim() method
function delInv()  {   
  for (var i in stim)  
  {  // i= item
    for (var j in stim[i]) 
    { // j= choices within item => j = 0 => match stimulus; j> 0 => sample stimulus                     
      for (var k in stim[i][j])  
      {   // k= shapes within choices
        if (stim[i][j][k][0] === 0)   delete(stim[i][j][k]);  // this works OK. tested with simple counter in drawStim(). don't use this: stim[i].splice(j, 1);
      }
    }
  }
}


// unbiased shuffle algorithm: Fisher-Yates (aka Knuth) Shuffle.
function shuffle(arr) {
  var cur_ind = arr.length, rnd_ind, tmp;
  // while there remain elements to shuffle...
  while (0 !== cur_ind) {    
    rnd_ind = Math.floor(Math.random() * cur_ind);     // pick a remaining element...
    cur_ind = cur_ind - 1;   
    tmp = arr[cur_ind];          // swap it with the current element.
    arr[cur_ind] = arr[rnd_ind];
    arr[rnd_ind] = tmp;  
    // don't forget to shuffle correct answers
    tmp = cor[cur_ind];          // swap it with the current element.
    cor[cur_ind] = cor[rnd_ind];
    cor[rnd_ind] = tmp;  
  }
  return arr;
}


// ger random integer from min to max range
function getRndInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


// draws a cross before the main stimulus, if set
function drawCross()  {
  var canvas= document.getElementById("canvas");   
  var x= Math.round(canvas.width/2);
  var y= Math.round(canvas.height/2);
  var d = Math.floor(Math.min(x,y)/4);  // 1/8 min(width, height)  
  drawLine(x-d,y,x+d,y); // horizontal
  drawLine(x,y-d,x,y+d); // vertical 
}


// draw line
function drawLine(x1,y1,x2,y2,col)  {
  if (!col) col= "#000000";      // default color is black
  var ctx= document.getElementById("canvas").getContext('2d'); 
  ctx.beginPath();
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);
  ctx.lineWidth= 1;
  ctx.strokeStyle=col;  
  ctx.stroke();     
}


// application thread time handler function
function wm6Timer()  
{  
   if (step<0) return;  // nop, idle
   step++;    
   var canvas= document.getElementById('canvas');         
   if (step < wait-1)  {   // time before main stimulus (points) period
      if (!isCross) return;   // idle, just wait main stimulus
      if (step % 2 !== 0)  {     // always trigger this in first timer call
        drawCross();     // draw Cross only if it is odd number  (1,3,5,..)  example if (before==6) = 3xflick            
      }
      else   {       // for even numbers  (2,4,6,..) => clear previous cross
        canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // clear canvas => clear Cross in 2,4,6 step                         
      }        
   }
   else if (step === wait-1)   {       // ALWAYS clear canvas before main stimulus display
     if (!isCross) return;   // idle, just wait main stimulus
     canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);      // clear last cross if exists                 
   }    
   else if (step === wait) {
     document.getElementById("prior").style.display= "none";
     drawStim(true);     // draw first part of stimulus (match)     
   }
   else if (step === wait+time) {
     canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);      // clear first part of stimulus  (stimulus before delay)     
   }
   else if (step >= wait+time+delay) {
     drawStim(false);     // after delay draw second part of stimulus (stimulus after delay)     
     document.getElementById("next").style.display= "inline";     
     step = -1;         // nop, idle, do none, Timer no operation     
   }
} 


/* draw (main) stimulus 
   if (first == true) => display first part of stimulus (stimulus before delay); 
   if (first == false) =>display all options (stimulus after delay); 
   if (first == null) only repaint selected answer: call from doAnswer()
*/   
function drawStim(first) 
{   
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas           
  for (var j in stim[item]) 
  {    // j= choices within item => j = 0 => match stimulus; j> 0 => sample stimulus           
    if (first && j != 0) {  
      continue; 
    }
    else if (!first && j== 0)   {
      continue;
    }
    // draw border around each choices bounds
    ctx.beginPath(); 
    ctx.strokeStyle= "#000000";
    /* [0] = left; [1] = top; [2] = right; [3]= bottom
        choice_width=  stim_b[j][2] - stim_b[j][0];  // right - left
        choice_height= stim_b[j][3] - stim_b[j][1]; // bottom - top    */  
    ctx.rect(stim_b[j][0],  stim_b[j][1], stim_b[j][2] - stim_b[j][0] ,  stim_b[j][3] - stim_b[j][1]);   // draw border around each choices bounds
    if (!first &&  ( (ans[item] == j) || (demo && cor[item] == j)) )  
    {                              
      // set background color for selected answer or set background color in demo mode for correct answer. you must call before drawShape() handler               
      // Gray90 == selected or Ivory == correct 
      ctx.fillStyle = (ans[item] == j)  ?   "#E5E5E5" : "#FFFFF0";  // the selected answer takes precedence over the correct answer (background color)
      ctx.fill();              
    }     
    ctx.stroke();    // draw border around each choices bounds
    for (var k in stim[item][j])   {   // k= shapes within choices [k]                        
      drawShape(ctx, stim[item][j][k][1], stim[item][j][k][2], stim[item][j][k][3], stim[item][j][k][4]);           
    }                           
  }           
  if (first != null) first= !first;     
}


/* shape function dispatcher (handler)
   ctx = canvas context
   x = x coord square center,
   y = y coord square center
   col = color (fillSyle and/or strokeStyle)
   shape = shape type => this argument is main for call different shapes.js function
   shapes.js file must be included in DOM  (wm6.html)
*/ 
function drawShape(ctx, x, y, col, shape)
{
   switch (shape)  
   {
     case 0:   // full circle
     case 1:   // 1/2 circle RIGHT oriented
     case 2:   // 1/2 circle DOWN oriented   
     case 3:   // 1/2 circle LEFT oriented
     case 4:   // 1/2 circle UP oriented 
     case 5:   // 3/4 circle with UP-RIGHT hole
     case 6:   // 3/4 circle with DOWN-RIGHT hole
     case 7:   // 3/4 circle with DOWN-LEFT hole 
     case 8:   // 3/4 circle with UP-LEFT hole                          
       if (shape === 0)  {                        
         circle(ctx, x, y, r, 0, 2*Math.PI, false, col);  // full circle 
       }        
       else if (shape === 1)  {
         circle(ctx, x, y, r, 1.5*Math.PI, 0.5*Math.PI, false, col); // 1/2 circle RIGHT oriented      
       }
       else if (shape === 2)  {
         circle(ctx, x, y, r, 0, Math.PI, false, col); // 1/2 circle DOWN oriented     
       } 
       else if (shape === 3)  {
         circle(ctx, x, y, r, 0.5*Math.PI, 1.5*Math.PI, false, col); // 1/2 circle LEFT oriented     
       } 
       else if (shape === 4)  {
         circle(ctx, x, y, r, Math.PI, 0, false, col);   // 1/2 circle UP oriented     
       }        
       else if (shape === 5)  {
         circle(ctx, x, y, r, 0, 1.5*Math.PI, false, col);   // 3/4 circle with UP-RIGHT hole     
       } 
       else if (shape === 6)  { 
         circle(ctx, x, y, r, 0, 0.5*Math.PI, true, col);   // 3/4 circle with DOWN-RIGHT hole     
       } 
       else if (shape === 7)  { 
         circle(ctx, x, y, r, 0.5*Math.PI, Math.PI, true, col);   // 3/4 circle with DOWN-LEFT hole     
       } 
       else if (shape === 8)  { 
         circle(ctx, x, y, r, 1.5*Math.PI, Math.PI, false, col);   // 3/4 circle with UP-LEFT hole     
       }        
       break;
        
     case 9:   // polygon 3 equal sides
     case 10:  // polygon 4 equal sides   
       (shape === 9) ?  polygon(ctx, x, y, r, 3, col):  polygon(ctx, x, y, r, 4, col);       
       break;    
          
     case 11:
       square(ctx, x, y, r, col);    
       break;
     
     case 12:    // longer side (base) down
     case 13:    // longer side (base) up
       (shape === 12) ? trapezoid(ctx, x, y, r, col, true) : trapezoid(ctx, x, y, r, col, false) ;  // base down or up   
       break;
      
     case 14: // rectangle - horizontal line is longer then vertical
     case 15: // rectangle - vertical line is longer then horizontal 
       (shape === 14) ? rectangle(ctx, x, y, r, col, true): rectangle(ctx, x, y, r, col, false);              
       break;
           
     case 16:
     case 17:
       if (shape === 16) {   // vertical ellipse
        var w= r, h= 2*r; // change this 2 param for PI/2 rotation
       }
       else {   // horizontal ellipse
        var w= 2*r, h= r; // change this 2 param for PI/2 rotation
       }
       ellipse(ctx, x - w / 2.0, y - h / 2.0, w, h, col);       
       break; 
        
     case 18: // cross => classic vertical cross
     case 19: // cross => diagonal cross (x) 
       (shape === 18) ? cross(ctx, x, y, r, col, true): cross(ctx, x, y, r, col, false);       
       break;   
     
     case 20:  //(base == true) => draw down-right rotated paralelogram; 
     case 21: // (base== false) => draw left-down rotated paralelogram
       (shape === 20) ? paralelogram(ctx, x, y, r, col, true): paralelogram(ctx, x, y, r, col, false);    
       break;
          
     // end of simple shapes mode (s_max=21) => 0..21
     
     case 22:   // star 4-points
     case 23:   // star 5-points
     case 24:   // star 6-points     
       star(ctx, x, y, shape-18, r/2, r, col);       
       break;
                    
     case 25:  //  vertical UP arrow (0)
     case 26:  //  vertical DOWN arrow (1)
     case 27:  //  horizontal LEFT arrow (2)
     case 28:  //  horizontal RIGHT arrow (3)
       arrow(ctx, x, y, r, col, shape-25);       
       break;
    
     case 29:  
     case 30:
       var a= (shape === 29) ? [r, r, 0, 0] : [0, 0, r, r];    // up rect round radius (31) or down round rect radius (32)
       roundRect(ctx, x-r, y-r, 2*r, 2*r, a, col);    
      break;
                 
      case 31:       // 1/4 circle segment UP-RIGHT oriented 
      case 32:       // 1/4 circle segment DOWN-RIGHT oriented
      case 33:       // 1/4 circle segment DOWN-LEFT oriented 
      case 34:       // 1/4 circle segment UP-LEFT oriented      
        quarter(ctx, x, y, r, shape-31, col);
        break;  
       
      case 35:
      case 36:
        (shape === 35) ? smiley(ctx, x, y, r, true, col): smiley(ctx, x, y, r, false, col); 
        break;
        
      case 37: 
      case 38:   
        //ctx.save();
        (shape === 37) ?  spiral(ctx, x, y, r, 0, 5, col) :  spiral(ctx, x, y, r, 3, 5, col);    // shape===33 => 5 spiral loops are visible; else draw spiral with 2 loops (first 3 are not visible)     
        //ctx.restore();
        break;
        
      case 39:  // polygon 5 equal sides
      case 40:  // polygon 6 equal sides      
      (shape === 39) ?  polygon(ctx, x, y, r, 5, col):  polygon(ctx, x, y, r, 6, col);       
      //break; 
                    
   }   // switch (shape) of
   
}  


// user selected answer (drawings) with mouse
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{
 if (step === -1 &&  document.getElementById("next").style.display === "inline" ) 
 {   // only after delay time when timer is idle state (after show second part of stimulus)
   for (var j= 1; j<=ch; j++) 
   {
      var x= e.clientX, y= e.clientY;     
      // stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch
      if ( x > stim_b[j][0] && x < stim_b[j][2] &&  y > stim_b[j][1] && y < stim_b[j][3])  
      {
        ans[item]=  (ans[item] === j) ? 0 : j;      // toggle (reset) answer if choose already selected answer of assign new answer        
        drawStim(null);
      }
 }
 } 
}


// goto next item (task)
function nextItem()  {              
  var canvas= document.getElementById('canvas');   
  canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);     // always clear canvas  after user navigation   
  item++; 
  if (item < itemCnt )         // (item < ans.length) or (item < cor.length)  or (item < stim.length)   => itemCnt = ans.length = cor.length=  stim.length 
  {    // show next task       
    document.getElementById("next").style.display= "none";
    document.getElementById("prior").style.display= "inline";       
    step=0;     // "activate" Timer again 
  }
  else  
  { 
    step= -1 ;   // redundant?                  
    theEnd();    
  }
}


//  stop timer and draw second part previous stimulus again (this is now previous item)
function undoAnswer()  {     
  step = -1;         // stop timer (nop, idle, do none, Timer no operation)                  
  if (item>0) item--;
  document.getElementById("next").style.display= "inline";
  document.getElementById("prior").style.display= "none";        
  drawStim(false);     // draw again second part of previous stimulus
}


// end of research
function theEnd()  {     
  document.getElementById("canvas").style.display="none";
  document.getElementById("next").style.display= "none";
  document.getElementById("prior").style.display= "none";
  document.getElementById("end").style.display="block";  
  var res=0;  
  for (var j=0; j!=cor.length; j++)   {
    if (cor[j] == ans[j]) res++;
  }
  var elem= document.getElementById("score");
  elem.textContent="Your score is: " + res + "   from possible: " + cor.length + ". Percentage= " + Math.round(100*res/cor.length) + "%";
  document.getElementById("google-wrapper").style.display="block";
  document.getElementById("no_google").textContent="";  
  
  try  {
    drawReport(res);  
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  }
  
  try 
  {
    if (store) {
      drawStorage(res);
    }
    else  {
      document.getElementById("table3").innerHTML= "";
    }
  }
  catch (e)  { 
    document.getElementById("table3").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
           
}


// async draw and display tables and charts with user results (call google API)..
function drawReport(res) 
{       
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Item number');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Answer');      
  data.addColumn('number', 'Correct'); 
  data.addColumn('number', 'Item score');      
  for(var i = 0; i < ans.length; i++)  
  {     
    var tmp= (ans[i] === cor[i]) ? 1: 0;
    if (tmp === 1)  {
      data.addRow([(i+1).toString() + ". item",  ans[i],  cor[i], tmp]);  
    }
    else  {
      data.addRow([(i+1).toString() + ". item",  ans[i],  cor[i],  {v: 0.1, f: '0'}]);  
    }
 }                    
  options= {
   title: 'Results for each item. Total score=' + res,
   width: '100%'   
  };    
  document.getElementById('chart').style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart')).draw(data, options);     // Create and draw the visualization.    
  
  //    xxxxxxxxxxxxxx          Frequencies table for each item       xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  var elem= document.getElementById("table");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  
  // draw table and chart for correct answer group by visible shape count (lc..hc)
  // compute frequencies => number of correct answer for each level (lc..hc)
  var freq= [];   // frequencies for correct answers for each level (number of visible shapes)
  for (var j = lc; j <= hc; j++)  {
    freq[j] = 0;      
  }                                 
  for (var i in stim) 
  {
    var j= 0;
    // delInv() must be used for this works correct!!
    for (var k in stim[i][0])   {     
       j++;
    }                                               
    if  (ans[i] === cor[i])   freq[j]++;
  }  
       
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Shape count');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Maximum score');      
  data.addColumn('number', 'Score');      
  for(var i in freq)  
  {     
    if (freq[i] > 0)  {
      data.addRow([ i.toString() + ". shapes",  wc,  freq[i] ]);     
    }
    else  {
      data.addRow([ i.toString() + ". shapes",  wc,  {v: 0.1, f: '0'} ]);
    }    
   }                 
  options= {
    title: 'Results are grouped by the number of displayed shapes. Total score = ' + res,
    width: '100%',  
    hAxis: {
      title: 'Number of displayed geometric shape',
    }, 
    vAxis: {
      title: 'Score'
    }   
  };    
  document.getElementById("chart2").style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart2')).draw(data, options);     // Create and draw the visualization.                       
        
   //    xxxxxxxxxxxxxx          Frequencies table group by level (number of visible shapes)       xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  var elem= document.getElementById("table2");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  
}


// get non-answered (escaped) item count - items with no answer
function getMissing()  {
  var res= 0;
  for(var i = 0; i < ans.length; i++)  {     
      if (ans[i] === 0) res++;
  }  
  return res;
}


// draw wm6 window.localStorage
function drawStorage(res)  
{  
  var oldItems = JSON.parse(localStorage.getItem("wm6-v1.0")) || []; 
  var id= oldItems.length+1;
  var mis=  getMissing();     
  // set new "record"
  var newItem = {
      'id': id,
      'date': new Date(),      
      'result': res, 
      'items': itemCnt,
      'Skip-items': mis,
      'Show-correct' : document.getElementById("demo").value,
      'Start-level' : document.getElementById("lc").value,
      'Final-level' : document.getElementById("hc").value,
      'Within-level' : document.getElementById("wc").value, 
      'Shuffle' : document.getElementById("is_shuffle").value,
      'Correct-exist' : document.getElementById("is_cor").value,
      'Time-between' : document.getElementById("wait").value,        
       'Time-display' : document.getElementById("time").value,
       'Time-delay' : document.getElementById("delay").value,       
       'Change' : document.getElementById("stype").options[document.getElementById("stype").selectedIndex].textContent,
       'Option-count' : document.getElementById("ch").value,
       'Shape size' : document.getElementById("size").value, 
       'Color' : document.getElementById("tcolor").value,
       'Cross' : document.getElementById("is_cross").value       
  };

  oldItems.push(newItem);

  localStorage.setItem("wm6-v1.0", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table3"), oldItems); 
  
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
  
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear WM6 web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("wm6-v1.0")  ?  JSON.parse(localStorage.getItem("wm6-v1.0")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no WM6 data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " WM6 results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved WM6 results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("wm6-v1.0"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
